<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class ESocialRepository {

    protected  $connection;

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getVersoesESocial($idativo) {
        $sql = <<<SQL
SELECT DISTINCT DSVERSAO
  FROM ESO_EVENTO
 WHERE (IDATIVO = :IDATIVO OR :IDATIVO IS NULL)
SQL;
        $params = array(
            "IDATIVO" => $idativo
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getEstruturasESocial($nrorg, $dtmescompetenc, $nrtipoestrutlegal, $idGrupo, $conditions) {
        $sql = <<<SQL
SELECT * FROM
    (SELECT EM.NRORG, EM.NRESTRUTURAM, EM.NMESTRUTURAM,
           EH.DTMESCOMPETENC, NVL(EH.CDCEIESTRUT,EH.CDCNPJESTRUT) CDCNPJESTRUT,
           EMP.NRESTRUTURAM NRESTRUTEMPREGADOR, EMP.NMESTRUTURAM NMESTRUTEMPREGADOR, EMP.CDCNPJESTRUT CDCNPJEMPREGADOR,
           EP.DTTRANSMISSAO, EP.DSVERSAO, EP.NRTPAMBIENTE, EP.NRPARCNEGOCIO, EP.IDBLOQEVENTPERIO, EP.DTREFNAOPERIOD,
           /*Identifica se e Matriz ou outro empregador que não seja pessoa juridica*/
           CASE
            WHEN (LENGTH(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','')) = 14 AND SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-',''),9,4) = '0001' AND EH.CDCEIESTRUT IS NULL)
                 OR (LENGTH(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','')) <> 14)
            THEN 'S'
            ELSE 'N'
           END IDMATRIZ,
           NVL((SELECT 'S' FROM FPA_ITECALCESTRUT IT
                  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                          AND CF.NRTIPOMOVIMENT = 1
                                          AND CF.NRTPMODALIDCAL = 1
                                          AND CF.NROCORRECAL = 1
                                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                 WHERE IT.NRORG = EM.NRORG
                   AND IT.NRESTRUTURAM = EM.NRESTRUTURAM
                   AND IT.DTOCORRENCIA = :P_DTMESCOMPETENC
                   AND IT.NREVENTOM = 3035
                   AND IT.IDATIVO = 'S'),'N') IDFECHAMENTO,
           NVL((SELECT 'S' FROM FPA_ITECALCESTRUT IT
                  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                          AND CF.NRTIPOMOVIMENT = 1
                                          AND CF.NRTPMODALIDCAL = 1
                                          AND CF.NROCORRECAL = 1
                                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                 WHERE IT.NRORG = EM.NRORG
                   AND IT.NRESTRUTURAM = EM.NRESTRUTURAM
                   AND IT.DTOCORRENCIA = :P_DTMESCOMPETENC
                   AND IT.NREVENTOM = 3036
                   AND IT.IDATIVO = 'S'),'N') IDREABERTURA,
           NVL((SELECT 'S' FROM FPA_ITECALCESTRUT IT
                  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                          AND CF.NRTIPOMOVIMENT = 4
                                          AND CF.NRTPMODALIDCAL = 1
                                          AND CF.NROCORRECAL = 1
                                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                 WHERE IT.NRORG = EM.NRORG
                   AND IT.NRESTRUTURAM = EM.NRESTRUTURAM
                   AND IT.DTOCORRENCIA = :P_DTMESCOMPETENC
                   AND IT.NREVENTOM = 3035
                   AND IT.IDATIVO = 'S'),'N') IDFECHAMENTO13,
           NVL((SELECT 'S' FROM FPA_ITECALCESTRUT IT
                  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                          AND CF.NRTIPOMOVIMENT = 4
                                          AND CF.NRTPMODALIDCAL = 1
                                          AND CF.NROCORRECAL = 1
                                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                 WHERE IT.NRORG = EM.NRORG
                   AND IT.NRESTRUTURAM = EM.NRESTRUTURAM
                   AND IT.DTOCORRENCIA = :P_DTMESCOMPETENC
                   AND IT.NREVENTOM = 3036
                   AND IT.IDATIVO = 'S'),'N') IDREABERTURA13
      FROM ESTRUTURAM EM
      LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                        AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                  WHERE ESTRUTURAH.NRORG = EH.NRORG
                                                    AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                    AND ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
      LEFT JOIN ESO_PARAMETRO EP ON EP.NRORG = EH.NRORG
                                AND EP.NRESTRUTURAM = EH.NRESTRUTURAM
                                AND EP.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                AND (EP.DTFIMVIGENCIA IS NULL OR EP.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
      /*Estrutura empregador - Matriz*/
      LEFT JOIN (SELECT EM.NRORG, MAX(EM.NRESTRUTURAM) NRESTRUTURAM, EH.NMRAZSOCESTRUT NMESTRUTURAM, EH.CDCNPJESTRUT
                   FROM ESTRUTURAM EM
                   JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                     AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                     AND EH.DTMESCOMPETENC = (SELECT MAX(ESTRUTURAH.DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE ESTRUTURAH.NRORG = EH.NRORG
                                                                 AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                 AND ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                  WHERE EM.NRORG = :P_NRORG
                    AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                    AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC
                    AND (EM.DTFIMVIGENCIA IS NULL OR EM.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                    AND EH.CDCEIESTRUT IS NULL
				  GROUP BY EM.NRORG, EH.NMRAZSOCESTRUT, EH.CDCNPJESTRUT) EMP ON EMP.NRORG = EH.NRORG
                                                   AND SUBSTR(REPLACE(REPLACE(REPLACE(EMP.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.'),'/'),'-'),1,8)
                                                   AND SUBSTR(REPLACE(REPLACE(REPLACE(EMP.CDCNPJESTRUT,'.'),'/'),'-'),9,4) = '0001'
     WHERE EM.NRORG = :P_NRORG
       AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
       AND EM.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
       AND (EM.DTFIMVIGENCIA IS NULL OR EM.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
       AND :P_IDGRUPO IS NOT NULL
     ORDER BY EH.CDCNPJESTRUT, EH.CDCEIESTRUT DESC)
 WHERE ((:P_IDGRUPO = 'P' AND IDMATRIZ = 'S') OR :P_IDGRUPO <> 'P')
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRTIPOESTRUTLEGAL" => $nrtipoestrutlegal,
            "P_IDGRUPO" => (is_array($idGrupo) ? '1': $idGrupo), //Parâmetro usado inicialmente apenas listar ou não as estruturas na tela de envios caso o menu esteja selecionado ou não
        );
        return $this->connection->fetchAll($sql . $conditions, $params);
    }

    public function getUniqueEnvioCadastros($nrestruturam, $nrtpambiente, $nmevento, $nrchave, $idoperacao, $dtmescompetenc) {
        $sql = <<<SQL
SELECT *
  FROM ESO_ENVIOCADASTROS EC
  JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                    AND EV.NMEVENTO = :NMEVENTO
 WHERE EC.NRORG = :NRORG
   AND EC.NRESTRUTURAM = :NRESTRUTURAM
   AND EC.NRTPAMBIENTE = :NRTPAMBIENTE
   AND EC.NRCHAVE = :NRCHAVE
   AND EC.IDOPERACAO = :IDOPERACAO AND EC.IDOPERACAO = 'I'
   AND (EC.DTMESCOMPETENC = :DTMESCOMPETENC OR :DTMESCOMPETENC IS NULL)
SQL;
        $params = array(
            "NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "NRESTRUTURAM" => $nrestruturam,
            "NRTPAMBIENTE" => $nrtpambiente,
            "NMEVENTO" => $nmevento,
            "NRCHAVE" => $nrchave,
            "IDOPERACAO" => $idoperacao,
            "DTMESCOMPETENC" => $dtmescompetenc,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getParamESocial($nrestruturam) {
        $sql = <<<SQL
SELECT EP.*,
       /*Empregador*/
       DECODE(EMP.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') as TPINSCRICAOEMP,
       REPLACE(REPLACE(REPLACE(CASE WHEN EMP.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN EMP.NRINSCRICAOPARC ELSE SUBSTR(EMP.NRINSCRICAOPARC,1,8) END,'.',''),'/',''),'-','') as NRINSCRICAOEMP,
       REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','') as CDCNPJESTRUT,
       /*Transmissor*/
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') as TPINSCRICAOPARC,
       REPLACE(REPLACE(REPLACE(PN.NRINSCRICAOPARC,'.',''),'/',''),'-','') as NRINSCRICAOPARC
  FROM ESO_PARAMETRO EP
  JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = EP.NRESTRUTURAM
                    AND EM.NRORG = EP.NRORG
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO EMP ON EMP.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
                     AND EMP.NRORG = EM.NRORG
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                     AND PN.NRORG = EP.NRORG
 WHERE EP.NRORG = :P_NRORG
   AND EP.DTINIVIGENCIA <= :P_DTMESCOMPETENC AND (EP.DTFIMVIGENCIA IS NULL OR EP.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
   AND (EP.NRESTRUTURAM = :P_NRESTRUTURAM OR EP.NRESTRUTURAM IS NULL)
   AND PN.NRINSCRICAOPARC IS NOT NULL
 ORDER BY EP.NRESTRUTURAM
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRESTRUTURAM" => $nrestruturam
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function getTagName($nrorg, $idativo = null, $dstagname = null) {
        $sql = <<<SQL
SELECT TN.DSTAGNAME, TN.DSTAGTRADUCAO, TN.DSCDOPCTAG, TN.DSNMOPCTAG
  FROM ESO_TAGNAME TN
 WHERE TN.NRORG = :P_NRORG
   AND (TN.IDATIVO = :P_IDATIVO OR (:P_IDATIVO IS NULL AND TN.IDATIVO = 'S'))
   AND (TN.DSTAGNAME = :P_TAGNAME OR :P_TAGNAME IS NULL)
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_IDATIVO" => $idativo,
            "P_TAGNAME" => $dstagname,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function updateEnvioVersao($nrorg, $nrestruturam, $dsversao) {
        $sql = <<<SQL
UPDATE ESO_ENVIOCADASTROS EC
   SET NREVENTO = (SELECT NEW.NREVENTO
                     FROM ESO_EVENTO OLD
                     JOIN ESO_EVENTO NEW ON NEW.NMEVENTO = OLD.NMEVENTO
                                        AND NEW.DSVERSAO = :P_DSVERSAO
                    WHERE OLD.NREVENTO = EC.NREVENTO)
 WHERE EC.NRORG = :P_NRORG
   AND EC.NRESTRUTURAM = :P_NRESTRUTURAM
   AND EC.IDSTATUS IN ('P','E','R')
   AND EC.IDATIVO = 'S'
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_DSVERSAO" => $dsversao,
        );
        
        $stmt = $this->connection->prepare($sql);
        return $stmt->execute($params);
    }
    
    public function excluirEventosProducaoRestrita($nrorg, $nrestruturam) {
        $sql = <<<SQL
DELETE FROM ESO_CADASTRO
      WHERE NRORG = :P_NRORG
        AND NRESTRUTURAM = :P_NRESTRUTURAM
        AND NRTPAMBIENTE = 2
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        
        $stmt = $this->connection->prepare($sql);
        
        $sql = <<<SQL
DELETE FROM ESO_NAOPERIODICO
      WHERE NRORG = :P_NRORG
        AND NRESTRUTURAM = :P_NRESTRUTURAM
        AND NRTPAMBIENTE = 2
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        
        $stmt = $this->connection->prepare($sql);
        
        $sql = <<<SQL
DELETE FROM ESO_PERIODICO
      WHERE NRORG = :P_NRORG
        AND NRESTRUTURAM = :P_NRESTRUTURAM
        AND NRTPAMBIENTE = 2
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        
        $stmt = $this->connection->prepare($sql);
        
        $sql = <<<SQL
DELETE FROM ESO_ENVIOCADASTROS
      WHERE NRORG = :P_NRORG
        AND NRESTRUTURAM = :P_NRESTRUTURAM
        AND NRTPAMBIENTE = 2
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        
        $stmt = $this->connection->prepare($sql);
        
        return $stmt->execute($params);
    }
    
    public function inativaEvento($nrorg, $nrestruturam, $nrenvio){
        $sql = <<<SQL
UPDATE ESO_ENVIOCADASTROS
   SET IDATIVO = 'N',
       NRORGULTATU = :P_NRORG,
       DTULTATU = SYSDATE,
       CDOPERULTATU = :P_CDOPERADOR
 WHERE NRORG = :P_NRORG
   AND NRESTRUTURAM = :P_NRESTRUTURAM
   AND IDATIVO = 'S'
   AND NRENVIO = :P_NRENVIO
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRENVIO" => $nrenvio,
            "P_CDOPERADOR" => $this->hcmParameters->getCdoperador(),
        );
            
        $stmt = $this->connection->prepare($sql);
        return $stmt->execute($params);
    }
    
    public function getVinculosAtivosSemLiquidoFechamento($nrorg, $dtmescompetenc, $nrtpmodalidcal, $nrtipomoviment, $dtocorrencia, $nreventom, $nrestrutlegal) {
        $sql = <<<SQL
SELECT *
  FROM FPA_CALCULOFOLHA CF
  JOIN FPA_ITECALCFOLHA IC ON IC.NRORG = CF.NRORG
                          AND IC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
  JOIN GPE_VINCULOM VM ON VM.NRORG = IC.NRORG
                      AND VM.NRVINCULOM = IC.NRVINCULOM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRORG = VH.NRORG
                                                  AND H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
WHERE CF.NRORG = :P_NRORG
  AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
  AND CF.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
  AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
  AND IC.NREVENTOM = :P_NREVENTOM
  AND VH.NRESTRUTLEGAL = :P_NRESTRUTLEGAL
  AND NOT EXISTS (SELECT 1 FROM FPA_ITECALCFOLHA I
                   WHERE I.NRORG = IC.NRORG
                     AND I.NRCALCULOFOLHA = IC.NRCALCULOFOLHA
                     AND I.NRVINCULOM = IC.NRVINCULOM
                     AND I.NREVENTOM = 3035)
 ORDER BY VM.NMVINCULOM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRTPMODALIDCAL" => $nrtpmodalidcal,
            "P_NRTIPOMOVIMENT" => $nrtipomoviment,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NREVENTOM" => $nreventom,
            "P_NRESTRUTLEGAL" => $nrestrutlegal,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getEnvioEventos ($nrtipoTabela, $nrchave, $nmevento, $nrorg, $nrorgpadrao, $nrvinculom){
        $query = $this->entityManager->getConnection()->prepare("
SELECT 
  EC.NRORG,
  EC.NRENVIO,
  EC.NRCHAVE,
  EC.NRTABELA,
  EC.IDSTATUS,
  EC.NRENVIOEXCL,
  EV.NMEVENTO
FROM
  ESO_ENVIOCADASTROS EC
  JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                      AND (EV.NRORG = EC.NRORG OR EV.NRORG = :P_NRORG_PADRAO)
JOIN GPE_VINCULOH VH ON VH.NRORG = EC.NRORG AND VH.NRVINCULOM = :P_NRVINCULOM AND VH.DTMESCOMPETENC = (
    SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
    WHERE NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
)
JOIN ESO_PARAMETRO EP ON EP.NRORG = EC.NRORG AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL 
WHERE
  EV.NMEVENTO = :P_NMEVENTO
  AND (EC.NRTABELA = :P_NRTABELA OR (EC.NRTABELA IS NULL AND :P_NRTABELA IS NULL))
  AND EC.NRORG = :P_NRORG
  AND EC.NRCHAVE = :P_NRCHAVE
  AND EC.NRTPAMBIENTE = EP.NRTPAMBIENTE
  AND EC.IDATIVO = 'S'
UNION ALL
SELECT 
  EN.NRORG,
  EN.NRENVIO,
  EN.NRCHAVE,
  EN.NRTABELA,
  EN.IDSTATUS,
  EN.NRENVIOEXCL,
  EN.NMEVENTO
FROM
  ESO_NAOPERIODICO EN
JOIN GPE_VINCULOH VH ON VH.NRORG = EN.NRORG AND VH.NRVINCULOM = :P_NRVINCULOM AND VH.DTMESCOMPETENC = (
    SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
    WHERE NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
)
JOIN ESO_PARAMETRO EP ON EP.NRORG = EN.NRORG AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL 
WHERE
  EN.NMEVENTO = :P_NMEVENTO
  AND (EN.NRTABELA = :P_NRTABELA OR ((EN.NRTABELA IS NULL OR EN.NRTABELA = 0) AND :P_NRTABELA IS NULL))
  AND EN.NRORG = :P_NRORG
  AND EN.NRCHAVE = :P_NRCHAVE
  AND EN.NRTPAMBIENTE = EP.NRTPAMBIENTE
  AND EN.IDATIVO = 'S'
        ");
            
        $query->execute(
            array(
                "P_NRTABELA"      => $nrtipoTabela,
                "P_NRCHAVE"       => $nrchave,
                "P_NMEVENTO"      => $nmevento,
                "P_NRORG"         => $nrorg,
                "P_NRORG_PADRAO"  => $nrorgpadrao,
                "P_DTMESCOMPETENC"=> $this->hcmParameters->getDtCompetencia(),
                "P_NRVINCULOM"    => $nrvinculom
            )
        );
        
        $itens = $query->fetchAll();
        $resultado[] = $itens;
        
        //busca por eventos S-3000 para os eventos encontrados, caso o campo NRENVIOEXCL esteja preenchido
        foreach($itens as $item){
            if($item['NRENVIOEXCL'] !== null && $itens !== null) {
                $query2 = $this->entityManager->getConnection()->prepare("
SELECT
  EC.NRORG,
  EC.NRENVIO,
  EC.NRCHAVE,
  EC.NRTABELA,
  EC.IDSTATUS,
  EC.NRENVIOEXCL,
  EV.NMEVENTO
FROM
  ESO_ENVIOCADASTROS EC
  JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                      AND (EV.NRORG = EC.NRORG OR EV.NRORG = :P_NRORG_PADRAO)
JOIN GPE_VINCULOH VH ON VH.NRORG = EC.NRORG AND VH.NRVINCULOM = :P_NRVINCULOM AND VH.DTMESCOMPETENC = (
    SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
    WHERE NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
)
JOIN ESO_PARAMETRO EP ON EP.NRORG = EC.NRORG AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL 
WHERE
  EC.NRORG = :P_NRORG
  AND (EC.NRTABELA = :P_NRTABELA OR (EC.NRTABELA IS NULL AND :P_NRTABELA IS NULL))
  AND EC.NRCHAVE = :P_NRCHAVE
  AND EC.NRENVIO = :P_NRENVIO
  AND EC.NRTPAMBIENTE = EP.NRTPAMBIENTE
  AND EC.IDATIVO = 'S'
UNION ALL
SELECT 
  EN.NRORG,
  EN.NRENVIO,
  EN.NRCHAVE,
  EN.NRTABELA,
  EN.IDSTATUS,
  EN.NRENVIOEXCL,
  EN.NMEVENTO
FROM
  ESO_NAOPERIODICO EN
  JOIN GPE_VINCULOH VH ON VH.NRORG = EN.NRORG AND VH.NRVINCULOM = :P_NRVINCULOM AND VH.DTMESCOMPETENC = (
    SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
    WHERE NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
)
JOIN ESO_PARAMETRO EP ON EP.NRORG = EN.NRORG AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL
WHERE
  EN.NRORG = :P_NRORG
  AND (EN.NRTABELA = :P_NRTABELA OR (EN.NRTABELA IS NULL AND :P_NRTABELA IS NULL))
  AND EN.NRCHAVE = :P_NRCHAVE
  AND EN.NRENVIOEXCL = :P_NRENVIO
  AND EN.NRTPAMBIENTE = EP.NRTPAMBIENTE
  AND EN.IDATIVO = 'S'
                ");
                
                 $query2->execute(
                    array(
                        "P_NRCHAVE"       => $item['NRCHAVE'],
                        "P_NRENVIO"       => $item['NRENVIOEXCL'],
                        "P_NRTABELA"      => $item['NRTABELA'],
                        "P_NRORG"         => $nrorg,
                        "P_NRORG_PADRAO"  => $nrorgpadrao,
                        "P_DTMESCOMPETENC"=> $this->hcmParameters->getDtCompetencia(),
                        "P_NRVINCULOM"    => $nrvinculom
                    )
                );
                $itens2 = $query2->fetchAll();
                

                $resultado[] = $itens2;
            }
        }
        return $resultado;
    }
    
    public function verififcaSeAdmissaoFoiEnviadaParaOESocial($nrorg, $nrvinculom){
        //Função criada para analisar se uma admissão pode ser excluída de acordo com os eventos do eSocial enviados 
        //retorna true se é possível realizar a exclusao da admissão, ou seja, se o evento de admissão (S-2200 ou S-2300) NÃO foi enviado para o eSocial ou se foi enviada mas um evento de EXCLUSÃO também foi enviado 
        //retorna false se não é possível realizar a exclusão da admissão, ou seja, se o evento (S-2200 ou S-2300) foi enviado, processado com sucesso para o eSocial e não foi excluído 
        $sql = <<<SQL
SELECT *
  FROM ESO_ENVIOCADASTROS
 WHERE NRORG =:P_NRORG
   AND NREVENTO IN (SELECT NREVENTO
                      FROM ESO_EVENTO
                     WHERE (NMEVENTO = 'S-2200' OR NMEVENTO = 'S-2206' OR NMEVENTO = 'S-2300' OR NMEVENTO = 'S-2306'))
   AND NRCHAVE = :P_NRVINCULOM
   AND IDSTATUS IN ('C','A') --Status enviado e processado com sucesso ou processado com advertências
   AND IDATIVO = 'S'
   AND NRENVIOEXCL IS NULL --Se NRENVIOEXCL é nulo a admissao foi enviada e nao ha envio do evento de esxclusao, logo a query não pode retornar registros
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRVINCULOM" => $nrvinculom
        );
        $resultadoConsulta = $this->connection->fetchAll($sql, $params);
        
        //Se a query retornar qualquer registro, um evento S-2200 ou S-2300 foi enviado para o eSocial e não foi excluído
        //Caso contrário, nenhum evento foi enviado ou se enviado existe um envio de evento de exclusão relacionado a ele, cancelando a operação
        return empty($resultadoConsulta);
    }

    public function ativaEvento($nrenvio, $nrorg, $nrestruturam){
        $sql = <<<SQL
UPDATE ESO_ENVIOCADASTROS
   SET IDATIVO = 'S',
       NRORGULTATU = :P_NRORG,
       DTULTATU = SYSDATE,
       CDOPERULTATU = :P_CDOPERADOR
 WHERE NRORG = :P_NRORG
   AND NRESTRUTURAM = :P_NRESTRUTURAM
   AND IDATIVO = 'N'
   AND NRENVIO = :P_NRENVIO
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRENVIO" => $nrenvio,
            "P_CDOPERADOR" => $this->hcmParameters->getCdoperador(),
        );

        $stmt = $this->connection->prepare($sql);
        return $stmt->execute($params);
    }
    
    public function getEnviosNaoPeriodicosPendentes ($nrchave, $nrorg, $status = 'P'){
        
        if (!is_array($status)) {
            $status = array($status);
        }
        
        // transforma os status passados como parametro em um valor válido para a cláusula IN
        $clausulaStatus = array_map( function($item) {
            return "'${item}'"; 
        }, $status);
        $clausulaStatus = "(".implode( $clausulaStatus, ', ') .")";
        
        $sql = "
SELECT EC.*,
       EV.DSVERSAO,
       EV.NMEVENTO,
       EV.DSEVENTO,
       EV.IDGRUPO,
       EM.NMESTRUTURAM,
       VH.CDMATRICULAESOCIAL,
       VM.NMVINCULOM AS DSCHAVE,
       VM.NRVINCULOM AS DSCDCHAVE, 
       PH.NRCPFPESSOA AS NRCPFPESSOA,
       '' AS ID
  FROM ESO_ENVIOCADASTROS EC 
  JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
  JOIN ESO_PARAMETRO EP ON EP.NRORG = EC.NRORG
                       AND EP.NRESTRUTURAM = EC.NRESTRUTURAM
                       AND EP.NRTPAMBIENTE = EC.NRTPAMBIENTE
  JOIN GPE_VINCULOM VM ON VM.NRORG = EC.NRORG 
                      AND VM.NRPESSOA = :P_NRCHAVE
  LEFT JOIN GPE_VINCULOH VH ON VM.NRORG = VH.NRORG
                           AND VM.NRVINCULOM = VH.NRVINCULOM
                           AND VH.DTMESCOMPETENC = (SELECT MAX(VHH.DTMESCOMPETENC)
                                                      FROM GPE_VINCULOH VHH
                                                     WHERE VHH.NRORG = VH.NRORG
                                                       AND VHH.NRVINCULOM = VH.NRVINCULOM
                                                       AND VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN GPE_PESSOAH PH ON PH.NRORG = EC.NRORG
                          AND PH.NRPESSOA = DECODE(EV.IDGRUPO, 'P', EC.NRCHAVE, 'N', VM.NRPESSOA, NULL)
                          AND PH.DTMESCOMPETENC = (SELECT MAX(PH1.DTMESCOMPETENC)
                                                     FROM GPE_PESSOAH PH1
                                                    WHERE PH1.NRORG = PH.NRORG
                                                      AND PH1.NRPESSOA = PH.NRPESSOA
                                                      AND PH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN ESTRUTURAM EM ON EM.NRORG = EC.NRORG
                         AND EM.NRESTRUTURAM = EC.NRESTRUTURAM
 WHERE EC.NRORG = :P_NRORG
   AND EV.IDGRUPO = :P_IDGRUPO
   AND EC.NRVINCULOM = VM.NRVINCULOM
   AND EC.IDSTATUS IN ${clausulaStatus}
   AND EC.IDATIVO = :P_IDATIVO
   AND (EC.DTMESCOMPETENC >= EP.DTREFNAOPERIOD OR EP.DTREFNAOPERIOD IS NULL)
 ORDER BY EC.DTMESCOMPETENC ASC";

        $params = array(
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRORG"          => $nrorg,
            "P_NRCHAVE"        => $nrchave,
            "P_IDGRUPO"        => 'N',
            // "P_IDSTATUS"       => $status,
            "P_IDATIVO"        => 'S'
        );
        
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function retornaVinculosEnvioEsocialRescisaoComplem($dataSet){
        $query = "SELECT GPE_VINCULOM.NRVINCULOM,
                         ESO_ENVIOCADASTROS.*,
                         ESO_PARAMETRO.DSVERSAO,
                         ESO_PARAMETRO.NRTPAMBIENTE,
                         ESO_EVENTO.NMEVENTO,
                         RESCCOMP.DTOCORRENCIA
                    FROM ESO_ENVIOCADASTROS
                    JOIN ESO_PARAMETRO ON ESO_PARAMETRO.NRESTRUTURAM = ESO_ENVIOCADASTROS.NRESTRUTURAM
                                       AND ESO_PARAMETRO.NRORG = ESO_ENVIOCADASTROS.NRORG
                                       AND ESO_PARAMETRO.IDATIVO = 'S'
                    JOIN ESO_EVENTO ON ESO_EVENTO.NREVENTO = ESO_ENVIOCADASTROS.NREVENTO
                                   AND ESO_EVENTO.NMEVENTO = 'S-2299'
                    JOIN GPE_VINCULOM ON GPE_VINCULOM.NRVINCULOM = ESO_ENVIOCADASTROS.NRCHAVE
                                     AND GPE_VINCULOM.NRORG = ESO_ENVIOCADASTROS.NRORG
                    JOIN FPA_CALCULOFOLHA CALCRESC ON CALCRESC.NRORG = GPE_VINCULOM.NRORG
                                                  AND CALCRESC.NRTIPOMOVIMENT = 1
                                                  AND CALCRESC.NRTPMODALIDCAL = 1
                                                  AND CALCRESC.NROCORRECAL = 1
                                                  AND TRUNC(CALCRESC.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
                    JOIN FPA_ITECALCFOLHA RESC ON RESC.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                              AND RESC.NRORG = GPE_VINCULOM.NRORG
                                              AND RESC.NREVENTOM = '3050'
                                              AND RESC.NRCALCULOFOLHA = CALCRESC.NRCALCULOFOLHA
                    JOIN FPA_CALCULOFOLHA CALCRESCCOMP ON CALCRESCCOMP.NRORG = GPE_VINCULOM.NRORG
                                                      AND CALCRESCCOMP.NRTIPOMOVIMENT = 1
                                                      AND CALCRESCCOMP.NRTPMODALIDCAL = 1
                                                      AND CALCRESCCOMP.NROCORRECAL = 2
                                                      AND TRUNC(CALCRESCCOMP.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
                    JOIN FPA_ITECALCFOLHA RESCCOMP ON RESCCOMP.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                                  AND RESCCOMP.NRORG = GPE_VINCULOM.NRORG
                                                  AND RESCCOMP.NREVENTOM = '3050'
                                                  AND RESCCOMP.NRCALCULOFOLHA = CALCRESCCOMP.NRCALCULOFOLHA
                   WHERE INSTR(','||ESO_ENVIOCADASTROS.NRCHAVE||',', ','||:P_NRVINCULOM||',') > 0
                     AND ESO_ENVIOCADASTROS.NRORG = :P_NRORG
                     AND ESO_ENVIOCADASTROS.IDATIVO = 'S'
                     AND ESO_ENVIOCADASTROS.NRENVIOEXCL IS NULL
                     AND ESO_ENVIOCADASTROS.NRTPAMBIENTE = 2
                     AND ESO_ENVIOCADASTROS.IDSTATUS IN ('C', 'A')
                     AND ((ESO_PARAMETRO.IDAPROVACALCRESC = 'S'AND EXISTS(SELECT 1
                                                                           FROM FPA_ITECALCFOLHA ITFEC 
                                                                          WHERE ITFEC.NRORG = RESC.NRORG
                                                                            AND ITFEC.NRVINCULOM = RESC.NRVINCULOM
                                                                            AND ITFEC.NREVENTOM = 3035
                                                                            AND ITFEC.NRCALCULOFOLHA = CALCRESC.NRCALCULOFOLHA)) 
                           OR NVL(ESO_PARAMETRO.IDAPROVACALCRESC, 'N') = 'N') 
                     AND ((ESO_PARAMETRO.IDAPROVACALCRESC = 'S'AND EXISTS(SELECT 1
                                                                           FROM FPA_ITECALCFOLHA ITFEC 
                                                                          WHERE ITFEC.NRORG = RESCCOMP.NRORG
                                                                            AND ITFEC.NRVINCULOM = RESCCOMP.NRVINCULOM
                                                                            AND ITFEC.NREVENTOM = 3035
                                                                            AND ITFEC.NRCALCULOFOLHA = CALCRESCCOMP.NRCALCULOFOLHA)) 
                           OR NVL(ESO_PARAMETRO.IDAPROVACALCRESC, 'N') = 'N')";
                           
        $params = array(
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRORG"          => $dataSet['NRORG'],
            "P_NRVINCULOM"     => $dataSet['NRVINCULOM']
        );
        return $this->connection->fetchAll($query, $params);                           
    }
}